routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->name('welcome');

Route::resource("genres", "App\Http\Controllers\GenreController");
Route::resource("authors", "App\Http\Controllers\AuthorController");
Route::resource("books", "App\Http\Controllers\BookController");

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Book extends Model
{
    use HasFactory;

    protected $fillable = ["isbn", "titulo", "numeroPaginas", "editorial", "idioma", "idGenero", "idAutor"];

    protected $primaryKey = "isbn";

    public function genres()
    {
        return $this->belongsTo("App\Models\Genre", "idGenero");
    }

    public function authors()
    {
        return $this->belongsTo("App\Models\Author", "idAutor");
    }

}

app/Http/Controllers/BookController.php
<?php

namespace App\Http\Controllers;

use App\Models\Author;
use App\Models\Book;
use App\Http\Requests\StoreBookRequest;
use App\Http\Requests\UpdateBookRequest;
use App\Models\Genre;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('books.index', ['books'=>Book::with(['genres', 'authors'])->get()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('books.create', ['genres'=>Genre::get(), 'authors'=>Author::get()]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreBookRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreBookRequest $request)
    {
        $fields = $request->validate([
            'isbn' => 'required|numeric',
            'titulo' => 'required|string',
            'numeroPaginas' => 'required|numeric',
            'editorial' => 'required|string',
            'idioma' => 'required|string',
            'idGenero' => 'required|numeric',
            'idAutor' => 'required|numeric',
        ]);

        Book::create($fields);

        return redirect()->route('books.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        return view('books.show', ['book' => $book]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        return view('books.edit', ['book'=>$book, 'genres'=>Genre::get(), 'authors'=>Author::get()]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateBookRequest  $request
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateBookRequest $request, Book $book)
    {
        $fields = $request->validate([
            'isbn' => 'required|numeric',
            'titulo' => 'required|string',
            'numeroPaginas' => 'required|numeric',
            'editorial' => 'required|string',
            'idioma' => 'required|string',
            'idGenero' => 'required|numeric',
            'idAutor' => 'required|numeric',
        ]);

        $book->update($fields);
        return redirect()->route('books.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        $book->delete();
        return redirect()->route('books.index');
    }
}

resources/views/books/create.blade.php
@extends('layout')

@section('title', 'Agregar Libro')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Insertar Libro</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton" href="{{ route('books.index') }}">Regresar</a>
        </div>
        <div class="row formulario">
            <fieldset>
                <form action="{{ route('books.store') }}" method="POST">
                    @csrf

                    <label for="isbn">ISBN</label>
                    <input type="number" name="isbn" required>

                    <label for="titulo">Título</label>
                    <input type="text" name="titulo" required>

                    <label for="numeroPaginas">Número de páginas</label>
                    <input type="number" name="numeroPaginas" required>

                    <label for="editorial">Editorial</label>
                    <input type="text" name="editorial" required>

                    <label for="idioma">Idioma</label>
                    <input type="text" name="idioma" required>

                    <label for="idGenero">Género</label>
                    <select name="idGenero" id="idGenero" required>
                        @foreach($genres as $genre)
                            <option value="{{ $genre->id }}">{{ $genre->nombre }}</option>
                        @endforeach
                    </select>

                    <label for="idAutor">Autores</label>
                    <select name="idAutor" id="idAutor" required>
                        @foreach($authors as $author)
                            <option value="{{ $author->id }}">{{ $author->nombre }}</option>
                        @endforeach
                    </select>

                    <div class="acciones">
                        <input class="boton" type="submit" value="Guardar">
                    </div>
                </form>
            </fieldset>
        </div>
    </div>
@endsection

resources/views/books/edit.blade.php
@extends('layout')

@section('title', 'Modificar Libro')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Modificar Libro</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton" href="{{ route('books.index') }}">Regresar</a>
        </div>
        <div class="row formulario">
            <fieldset>
                <form action="{{ route('books.update', $book) }}" method="POST">
                    @csrf
                    @method('PATCH')

                    <label for="isbn">ISBN</label>
                    <input type="number" name="isbn" value="{{ $book->isbn }}" required readonly>

                    <label for="titulo">Título</label>
                    <input type="text" name="titulo" value="{{ $book->titulo }}" required>

                    <label for="numeroPaginas">Número de páginas</label>
                    <input type="number" name="numeroPaginas" value="{{ $book->numeroPaginas }}" required>

                    <label for="editorial">Editorial</label>
                    <input type="text" name="editorial" value="{{ $book->editorial }}" required>

                    <label for="idioma">Idioma</label>
                    <input type="text" name="idioma" value="{{ $book->idioma }}" required>

                    <label for="idGenero">Género</label>
                    <select name="idGenero" id="idGenero" required>
                        @foreach($genres as $genre)
                            <option value="{{ $genre->id }}" {{ $genre->id === $book->idGenero ? 'selected' : '' }}>{{ $genre->nombre }}</option>
                        @endforeach
                    </select>

                    <label for="idAutor">Autores</label>
                    <select name="idAutor" id="idAutor" required>
                        @foreach($authors as $author)
                            <option value="{{ $author->id }}" {{ $author->id === $book->idAutor ? 'selected' : '' }}>{{ $author->nombre }}</option>
                        @endforeach
                    </select>

                    <div class="acciones">
                        <input class="boton" type="submit" value="Guardar">
                    </div>
                </form>
            </fieldset>
        </div>
    </div>
@endsection

resources/views/books/index.blade.php
@extends('layout')

@section('title', 'Libros')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Libros</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton me-2" href="{{ route('welcome') }}">Regresar</a>
            <a class="boton" href="{{ route('books.create') }}">Agregar Libro</a>
        </div>
        <div class="row">
            @if(!$books->isEmpty())
                <div class="container tabla">
                    <div class="row encabezado">
                        <div class="col-12 col-md-3 columna">ISBN</div>
                        <div class="col-12 col-md-3 columna">Título</div>
                        <div class="col-12 col-md-6 columna">Acciones</div>
                    </div>
                    @foreach($books as $book)
                    <div class="row contenido">
                        <div class="col-12 col-md-3 columna">{{ $book->isbn }}</div>
                        <div class="col-12 col-md-3 columna">{{ $book->titulo }}</div>
                        <div class="col-12 col-md-6 acciones columna">
                            <a class="boton mostrar col" href="{{ route('books.show', $book) }}">Mostrar</a>
                            <a class="boton editar col" href="{{ route('books.edit', $book) }}">Editar</a>
                            <form class="col" action="{{ route('books.destroy', $book) }}" method="POST">
                                @csrf
                                @method('DELETE')
                                <input class="boton eliminar" type="submit" value="Eliminar">
                            </form>
                        </div>
                    </div>
                    @endforeach
                </div>
            @else
                <div class="col">
                    No existen libros para mostrar
                </div>
            @endif
        </div>
    </div>
@endsection

resources/views/books/show.blade.php
@extends('layout')

@section('title', 'Mostrar Libro')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>{{ $book->isbn }}</h1>
        </div>
        <div class="row acciones">
            <a class="boton" href="{{ route('books.index') }}">Regresar</a>
        </div>
        <div class="row contenido">
            <h2>ISBN: {{ $book->isbn }}</h2>
            <h2>Título: {{ $book->titulo }}</h2>
            <h2>Número de páginas: {{ $book->numeroPaginas }}</h2>
            <h2>Editorial: {{ $book->editorial }}</h2>
            <h2>Idioma: {{ $book->idioma }}</h2>
            <h2>Género: {{ $book->genres->nombre }}</h2>
            <h2>Autor: {{ $book->authors->nombre . " " . $book->authors->apellidos }}</h2>
        </div>
    </div>
@endsection